<template>
  <div class="guest_page">
    <div class="bg-wrapper">
      <Background></Background>
    </div>
    <div class="guest_page_container">
      <div clas="logo_container">
        <router-link :to="{name: 'Login'}" class="logo_link">
          <img :src="`${$baseUrl}/images/logo-HETA2.png`" alt="HETACHAIN" class="img">
        </router-link>
        <div class="guest_page_form">
          <div class="form-container">
            <div class="guest_page_form_header">
              <div class="title">{{ $t('auth.register.title') }}</div>
              <div class="sub_title">{{ $t('auth.register.sub_title') }}</div>
            </div>

            <div class="guest_page_form_body">
              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-email"></i>
                </div>
                <input @keyup.enter="register"
                       v-validate="'required|email|max:255'"
                       data-vv-validate-on="none"
                       @focus="resetError"
                       :placeholder="$t('auth.placeholder.email')"
                       v-model="user.email"
                       name="email"
                       type="text"
                       class="form_input">
                <span class="invalid-feedback" v-if="errors.has('email')">
                  {{ errors.first('email') }}
                  <a href="javascript:void(0)" style="text-decoration: underline" v-if="errors.first('email') === $t('validation.verify_pending_email', {attribute: 'email'})"
                     @click="sendVerifyUser"> {{$t('sign.resend')}}</a>
                </span>
              </div>

              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-password"></i>
                </div>
                <input
                  @keyup.enter="register"
                  v-validate="'required|min:6|max:128|regex:^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d).+$|no_space|confirmed:password_confirmation'"
                  data-vv-validate-on="none"
                  @focus="resetError"
                  :placeholder="$t('auth.placeholder.password')"
                  v-model="user.password"
                  v-tooltip="$t('auth.register.password_tooltip')"
                  name="password"
                  type="password"
                  class="form_input">
                <span class="invalid-feedback" v-if="isShowPasswordError">{{ errors.first('password') }} </span>
              </div>
              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-password"></i>
                </div>
                <input
                  data-vv-as="password confirmation"
                  @keyup.enter="register"
                  data-vv-validate-on="none"
                  ref="password_confirmation"
                  v-validate="'required'"
                  @focus="resetError"
                  :placeholder="$t('auth.placeholder.repeat_password')"
                  v-model="user.password_confirmation"
                  name="password_confirmation"
                  type="password"
                  class="form_input">
                <span class="invalid-feedback"
                      v-if="isShowPasswordConfirmedError">{{ errors.first('password') }}</span>
                <span class="invalid-feedback"
                      v-if="errors.has('password_confirmation')">{{ errors.first('password_confirmation') }}</span>
              </div>

              <div class="input_group">
                <div class="input_group_prepend">
                  <i class="iconmo-ID"></i>
                </div>
                <input
                  data-vv-as="Referral code"
                  @keyup.enter="register"
                  data-vv-validate-on="none"
                  @focus="resetError"
                  :placeholder="$t('auth.placeholder.referral_code')"
                  v-model="user.referral_id"
                  name="referral_id"
                  type="text"
                  class="form_input">
                <span class="invalid-feedback" v-if="errors.has('referral_id')">
                {{ errors.first('referral_id') }}
              </span>
              </div>

              <div class="checked_group">
                <input v-model="isAccpeted"
                       id="inline-checkbox1"
                       data-vv-validate-on="none"
                       name="agree"
                       type="checkbox"
                       v-validate="'required'"
                       class="form_check_input">
                <label for="inline-checkbox1" class="form-check-label">
                  {{ $t('auth.register.terms.agree') }} <a target="_blank" class="text-white" href="/terms">{{ $t('auth.register.terms.title') }}</a>
                </label>
                <span class="invalid-feedback" v-show="errors.has('agree')">{{ $t('auth.register.terms.error') }}</span>
              </div>

              <div class="form_actions">
                <button type="button" class="button-primary" @click="register">{{ $t('auth.btn.upper_register') }}</button>
              </div>

              <div class="login_box">
                <label class="form-check-label text-normal">
                  {{ $t('auth.register.note') }}
                  <a class="text-orange" href="javascript:void(0)" @click="goToLoginPage">{{ $t('auth.btn.login') }}</a>
                </label>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <guest-page-footer></guest-page-footer>
    <modal v-if="displayModal" @close="modalOff">
      <component v-bind:is="currentModal" :modal-data="modalData"></component>
    </modal>
  </div>
</template>
<script>
  import { mapState } from 'vuex';
  import rf from '../../../common/requests/RequestFactory';
  import ModalMixin from '../../../common/components/ModalMixin';
  import CheckAuthMixin from './CheckAuthMixin';
  import RegisterSuccessfulModal from './Modal/RegisterSuccessfulModal.vue';
  import GuestPageFooter from '../../components/GuestPageFooter.vue';
  import Background from '../../components/Dashboard/Background';

  export default {
    components: {
      GuestPageFooter,
      Background
    },
    data () {
      return {
        isAccpeted: false,
        user: {
          email: '',
          password: '',
          password_confirmation: '',
          referral_id: ''
        }
      };
    },
    computed: {
      ...mapState([
        'supportedLocales',
      ]),
      isShowPasswordError () {
        return this.errors.has('password') && !this.errors.firstByRule('password', 'confirmed');
      },
      isShowPasswordConfirmedError () {
        return !!this.errors.firstByRule('password', 'confirmed') && !this.errors.firstByRule('password_confirmation', 'required');
      }
    },
    mixins: [CheckAuthMixin, ModalMixin],
    methods: {
      sendVerifyUser() {
        if (this.user && this.user.email) {
          rf.getRequest('UserRequest').sendVerifyUser({email: this.user.email}).then(() => {
            this.$toasted.show(this.$t('sign.resend_successful'), {
              theme: 'bubble',
              position: 'top-right',
              duration: 2000
            });
          });
        }
      },
      resetError () {
        this.errors.clear();
      },
      goToLoginPage () {
        this.$router.push('/login');
      },
      register () {
        this.$validator.validateAll()
          .then(() => {
            if (this.errors.any() || !this.isAccpeted) {
              return;
            }
            rf.getRequest('UserRequest').create(this.user)
              .then(res => {
                window.localStorage.removeItem('referralId');
                this.$broadcast('open-modal', RegisterSuccessfulModal, res.data);
              })
              .catch((error) => {
                const errors = error.errors;
                this.errors.clear();
                Object.keys(errors).forEach((key) => {
                  this.errors.add({
                    field: key,
                    msg: errors[key][0]
                  });
                });
              });
          });
      },
    },
    created () {
      const url = new window.URL(window.location.href);
      const referralId = url.searchParams.get('referral_id');
      if (referralId) {
        window.localStorage.setItem('referralId', referralId);
      }
      this.user.referral_id = window.localStorage.getItem('referralId') || '';
    }
  }
</script>
<style lang="scss" scoped>
  .guest_page_form {
    margin-top: -24px !important;
    padding-left: 36px !important;
  }
  .guest_page_form_header .sub_title {
    margin-top: 10px!important;
  }
  .guest_page_form_body {
    margin-top: 17px;
  }
  .form_input {
    width: 100% !important;
    /*padding-left: 28px !important;*/
  }
  .text-white {
    color: white;
  }
  .checked_group {
    font-family: Roboto;
    font-size: 14px;
    color: #989898;

    padding-left: 5px;
    position: relative;
    margin-bottom: 20px;
    .form_check_input {
      font-size: 10px;
      position: absolute;
      top: 5px;
      left: 15px;
    }
    .form-check-label {
      padding-left: 28px;
    }
  }
  .login_box {
    text-align: center;
    margin-top: 19px;
  }
  .text-orange {
    font-size: 12px;
    margin-left: 8px;
    position: relative;
    left: -4px;
  }
  .logo_link {
    display: inline-block;
  }

  @media screen and (max-width: 1023px) {
    .logo_link {
      margin-bottom: 40px;
    }
    .guest_page_container {
      text-align: center;
    }
    .guest_page {
      .guest_page_form {
        display: block;
        position: static;
        transform: translateY(0);
        padding-left: 0 !important;

        .form-container {
          margin: 0 auto;
          text-align: left;
        }
      }
    }
  }
</style>
